# coding=utf-8
import wizard
import netsvc
import pooler
from osv import osv

class wiz_product_acm(wizard.interface):
	_done_form = '<?xml version="1.0"?><form string="ACM"><label string="Concluído!"/></form>'	
		
	def _calc_acm (self, cr, uid, data, context):
		product_id = data['id']
		cr.execute('SELECT id FROM mrp_bom WHERE product_id=%d', [product_id])
		if cr.rowcount <= 0:
			raise UserWarning, 'BoM não econtrada!'
			
		bom_id = cr.fetchone()[0]
		bom = pooler.get_pool(cr.dbname).get('mrp.bom').browse(cr, uid, [bom_id])[0]

		self.acm = 0
		def recursion_sum(cr, uid, bom):
			print bom, self.acm
			if bom.bom_lines:
				tmpl = bom.product_id.product_tmpl_id
				factor = tmpl.uom_po_id.factor
				self.acm += factor * tmpl.standard_price  * bom.product_qty
				for b in bom.bom_lines:
					recursion_sum(cr, uid, b)
			else:
				tmpl = bom.product_id.product_tmpl_id
				factor = tmpl.uom_po_id.factor
				self.acm += factor * tmpl.standard_price * bom.product_qty

		recursion_sum(cr, uid, bom)
		print self.acm
		
		#TODO: Gravar o ACM no produto.
		
		return {}
		
	states = {
		'init': {
			'actions': [_calc_acm],
			'result': {'type': 'form', 'arch':_done_form, 'fields':{}, 'state':[('end','Fechar')]}
		},
	}
wiz_product_acm('product.acm')
